extends Node2D

var boxTotal := 4
var timer:= Timer.new()
var countdown := 10
var totalCrates := 0
var cratesDestroyed := 0
var totalCoins := 0
var totalCoinsCollected := 0
var totalBadGuys := 0

var player:Resource

#level information
var levels = ["res://scenes/game.tscn","res://scenes/level2.tscn"]
var timers = [10, 15]
var currentLevel = 0

#Signals from GC
signal destroyBox(body)
signal levelComplete(levelToLoad)

# Called when the node enters the scene tree for the first time.
func _ready() -> void:
	player = load("res://scripts/res/playerstats.tres")
	print("Player health "+str(player.health))
	
	print("Number of levels: "+str(levels.size() ) )
	reset()
	add_child(timer)
	timer.wait_time = 1
	timer.one_shot = false
	timer.connect("timeout", secondCounter)
	timer.start()

func reset():
	countdown = timers[currentLevel]
	
func secondCounter():
	
	countdown -=1
	if countdown <=0:
		print("YOU LOSE")
		levelComplete.emit(levels[currentLevel])
func coinCollected():
	totalCoinsCollected += 1
	print("GC knows coin collected")
func playerDamaged():
	print("GC knows player taking damage")
	player.health -= 20
	print("Health remaining: "+str(player.health))
	
func bulletHit(body):
	print("Game controller knows bullet hit something")
	if body.is_in_group("destructable"):
		destroyBox.emit(body)
		totalCrates -=1
		cratesDestroyed +=1
		if totalCrates <=0:
			print("YOU WON!!")
			#refactor this - make it a signal
			currentLevel +=1
			if currentLevel >= levels.size():
				currentLevel = 0
			levelComplete.emit(levels[currentLevel])
		else:
			print("Crates Remaining "+str(totalCrates) )
# Coming from SceneManager
func countCrates(value):
	totalCrates = value
func countCoins(value):
	totalCoins = value
func countBadGuys(value):
	totalBadGuys = value
